; NEU 20060401
; 20220128 AN: ARRAYCLASSIC statt ARRAY
;*********************************************************************
; HektarLayer einbau Var:
; ADR_HMAP_HEKT_KR_Layer        ... "k-p"
(setq ADR_HMAP_HEKT_KR_Layer "k-p")
; ADR_HMAP_HEKT_SCHR_Layer      ... "k-s"
(setq ADR_HMAP_HEKT_SCHR_Layer "k-s")
;blocknamen
; ADR_HMAP_HEKT_KR_Blockname    ... GDS5
(setq ADR_HMAP_HEKT_KR_Blockname "GDS5")
; ADR_HMAP_HEKT_SCHR_Blockname  ...
(setq ADR_HMAP_HEKT_SCHR_Blockname "GDS6")

(vl-doc-export 'ADR_HMAP_Setup_HEKT)
(defun ADR_HMAP_Setup_HEKT ( KR_Layer SCHR_Layer KR_Blockname SCHR_Blockname / )
  (setq ADR_HMAP_HEKT_KR_Layer KR_Layer)
  (setq ADR_HMAP_HEKT_SCHR_Layer SCHR_Layer)
  (setq ADR_HMAP_HEKT_KR_Blockname KR_Blockname)
  (setq ADR_HMAP_HEKT_SCHR_Blockname SCHR_Blockname)
)





;*********************************************************************
;AUS LIB ZUSAMMENGEKUPFERT
(defun adr_setlayer ( wert /)
  (if wert
    (if (not (tblsearch "LAYER" "Wert"))
; !!! Achtung hier mu noch die farbe usw aus der konfig gelesen werden     
      (command "_layer" "_m" wert "" )
      (command "_layer" "_th" wert "_on" wert "_s" wert) 
    )
  )
)
(setq adr_textrot_minwert      (/ PI 2)  )
(setq adr_textrot_maxwert (* 3 (/ PI 2)) )
(setq adr_symbol_path "HMap/Symbols/")
(Defun HMAP_Symbol_Path ( path / )
  (setq adr_symbol_path path)
)
(vl-acad-defun  'HMAP_Symbol_Path)
(Defun c:HMAP_Symbol_Path ( path / )
  (setq adr_symbol_path (if (setq temp (getstring (stract "Neuer Pfad fr HMap Symbole <" adr_Symbol_path ">:"))) temp adr_Symbol_path))
)
(defun scale ( / )
  (if (setq  sc (cdr (assoc '1040 (cdr (cadr (assoc '-3 (ADR_getmodelspace '("HMapDWG"))))))))
    sc
    (progn
      (Prompt "HMAP-Mastabswert ist nicht gesetzt")
      1000
    )  
  )  
)
(defun ADR_getmodelspace ( eed / x e)
  (vl-load-com) ;sollte auch ohne funktionieren aber zur sicherheit
  (setq x (vla-get-ModelSpace (vla-get-ActiveDocument (vlax-get-acad-object))))
  (if x (setq e (vlax-vla-object->ename x)))
  (if e (entget e eed))
)
(defun adr_cmdbegin (/)
  (setvar "expert" 5)
  (setvar "CMDECHO" 0)
  (command "_undo" "_g")
  (setq ADR_OLDLAYER (getvar "CLAYER"))
  (setq ADR_OLDATTREQ (getvar "ATTREQ"))
  (setq ADR_OLDEXPERT (getvar "EXPERT"))
  (setq ADR_OLDSnapmode (getvar "Snapmode"))
  (setq ADR_OLDOSmode (getvar "osmode"))
  (setq ADR_OLDAttdia (getvar "attdia"))
  (setq ADR_OLDAngbase (getvar "angbase"))
  (setq adr_oldSnapang (getvar "SNAPang"))
  (setq adr_oldAngDir (getvar "angdir" ))
  
  (setvar "attdia" 0)
  (setq adr_oldpickstyle (getvar "pickstyle"))
  ;(setvar "pickstyle" 0) achtung wegen gruppen diese ber naen und funktion aus und einschalten 
  (setvar "attreq" 1)
  
)
(defun adr_cmdende ( Progname Reg /)
  (setvar "Snapmode" ADR_OLDSnapmode)
  (setvar "CLAYER" ADR_OLDLAYER)
  (setvar "osmode" ADR_OLDOSmode)
  ;(setvar "pickstyle" adr_oldpickstyle)achtung wegen gruppen diese ber naen und funktion aus und einschalten 
  (setvar "attdia" adr_oldattdia)
  (setvar "attreq" ADR_OLDATTREQ)
  (setvar "EXPERT" ADR_OLDEXPERT)
  (setvar "angbase" ADR_OLDANGBASE)
  (setvar "Snapang" adr_oldSnapang)
  (setvar "angdir" adr_oldAngDir)
  (if reg (command "_regenall"))
  (command "_undo" "_e")
  (setvar "CMDECHO" 1)
  (setvar "expert" 0)
  (prompt "\n(c) 1996-2005  Ingenieur Studio HOLLAUS  www.hollaus.at  0664/3387159")
  (prompt (strcat "\n" Progname " Fertig "))

  (princ)
)
;*********************************************************************


;Hektarnetz
(defun heksin (mfak / ip )
  (while (setq ip (getpoint "Einsetzpunkt"))
      ;(command "_insert" (strcat adr_symbol_path "gds5") "_none" ip mfak "" "")
       (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_KR_Blockname) "_none" ip mfak "" "")
    )
  (setq ip nil)
)

;UEBER FENSTER
(defun ADR_hekwin ( mfak / p1 p2 p1T p2T)
  (princ "Hektarnetz ueber Fenster waehlen:")
  (print)
  (setq p1T (getpoint "linker unterer Randpunkt:")
        p2T (getpoint "rechter oberer Randpunkt:"))
  (setq p1 (list (min (car p2T)(car p1T)) (min(cadr p1T)(cadr p2T))))
  (setq p2 (list (max (car p2T)(car p1T)) (max(cadr p1T)(cadr p2T))))
  ;(setq p2 (list (car p1T) (cadr p2T)))	
  
  (setvar "cmdecho" 1)
  (setvar "Snapang" 0) ;weils davor fr eingabe verndert wird !
  (if (and p1 p2) 
      ;(command "_insert" (strcat adr_symbol_path "gds5") "_None" p1 mfak "" ""
      (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_KR_Blockname) "_None" p1 mfak "" ""
	       "_arrayclassic" (ssadd (entlast)) "" "_r"
                         (fix (+ 1.01 (/ (abs (- (cadr p2) (cadr p1))) abst)))
 	                 (fix (+ 1.01 (/ (abs (- (car p2) (car p1))) abst)))
			 (abs abst)
			 (abs abst)
      )
  )
  (setq p1 nil p2 nil)
)

;HAUPTPROGRAMM mit SETZEN DER BESCHRIFTUNG
(defun C:HEKTAR ( / a ip y x mfak osmode angbase snapmode)
  (adr_cmdbegin )
  (setq *error* 'Hmap_Hektar_Fehler)
;  (setq snapmode (getvar "snapmode"))
  (setvar "snapmode" 0)
;  (setq osmode (getvar "osmode"))
;  (setq angbase (getvar "angbase"))
  (setvar "angbase" 0)
  (setvar "osmode" 0)
  (setvar "Snapang" 0)
  (setvar "angdir" 0)
  (adr_setlayer ADR_HMAP_HEKT_KR_Layer)
    ;(adr_setlayer "k-p") alt vor 20060401
  ; !!! massstab aus allgemeinen Daten bernehmen
  (setq mfak (/ (scale) 1000))
  (setq abst (getreal "Abstand (in m <100>):"))
  (if (not abst) (setq abst 100))
  (command "_snap" abst "_snap" "_r" "0,0" (angtos (/ PI 2) (getvar "Aunits") 10))
  (setvar "SNAPTYPE" 0)	;fuer BricsCAD, da sonst adaptiver SNAP agiert und nicht festes Raster
  (setq a (getstring "Marken einzeln einsetzen ? <n> "))
  (if (or (= a "j") (= a "J") ) (heksin mfak ) (ADR_hekwin mfak ))
  (adr_setlayer ADR_HMAP_HEKT_SCHR_Layer)
  ;(adr_setlayer "k-s")
  (while (setq ip (getpoint "Wohin Beschriftung ?"))
         (setq y (strcat "y = " (rtos (car ip) 2 2))
               x (strcat "x = " (rtos (cadr ip) 2 2))
         )  
         (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_SCHR_Blockname) "_none" ip mfak "" (atof(angtos 0)) x y)
  )
;  (setvar "osmode" osmode)
;  (setvar "snapmode" snapmode)
;  (setvar "angbase" angbase)

  (setq *error* nil)
  (adr_cmdende "HMap - Hektarnetz" nil)
)

(defun Hmap_Hektar_Fehler ( msg / )
  (adr_cmdende "Fehler in HMap - Hektarnetz" nil)
  ;(print "ende mit fehler")
)

(defun c:hektarbeschr (/ mfak x y ip )
  ;!!!layer setzen laut datenbank
  (adr_cmdbegin )
  (setq *error* 'Hmap_Hektar_Fehler)
;; (setq snapmode (getvar "snapmode"))
  ;(setvar "snapmode" 0)
 ; (setq osmode (getvar "osmode"))
;  (setq angbase (getvar "angbase"))
  
  ;(setvar "osmode" 0)
  (setvar "angbase" 0)
  (adr_setlayer ADR_HMAP_HEKT_SCHR_Layer)
  (setvar "Snapang" 0)
  (setvar "angdir" 0)
  (setq mfak (/ (scale) 1000))
  ;(setvar "snapmode" 0)
  (while (setq ip (getpoint "Wohin Beschriftung ?"))
    (setq y (strcat "y = " (rtos (car ip) 2 2))
          x (strcat "x = " (rtos (cadr ip) 2 2))
    )  
    (command "_insert" (strcat adr_symbol_path ADR_HMAP_HEKT_SCHR_Blockname) "_none" ip mfak "" (atof(angtos 0)) x y)
  )
;  (setvar "osmode" osmode)
;  (setvar "snapmode" snapmode)
;  (setvar "angbase" angbase)  
  ;!!! layer zurcksetzen
  (setq *error* nil)
  (adr_cmdende "HMap - Hektarnetz" nil)
)  
